def test_certifyNonQM(a0,a1,a2,a3,a4,a5=1,a6=0,verbose=false):
	poly=ZZ['x']([a0,a1,a2,a3,a4,a5,a6])
	discPoly=poly.discriminant();
	for p in range (3,100):
		if is_prime(p) and discPoly % p != 0 :
			q=Frobenius_Polynomial(p,a0,a1,a2,a3,a4,a5,a6)
			q=twistPoly12(q)

			if(q.is_square() == false) :
				return true
	return false;

def test_certifyQM(a0,a1,a2,a3,a4,a5=1,a6=0,verbose=false,MaxDiscriminant=41):
	HumbertTest=[0 for j in range(MaxDiscriminant)]
	for d in range(5,MaxDiscriminant):
		if(d <= 24 or d%4 == 0):
			HumbertTest[d]=(1 if HTest(d,a0,a1,a2,a3,a4,a5,a6,verbose) else 0);

	if(verbose):
		print("Result of Humbert surfaces tests:", HumbertTest);

	s= sum(HumbertTest);

	'''
	if our surface lies on just one Humbert surface quit returning false
	'''
	if s<2 :
		return false;

	'''
	look for the Humbert surface of least discriminant containing the moduli point corresponding to our variety
	'''
	for j in range(5,MaxDiscriminant):
		if(HumbertTest[j] == 1):
			F=j;
			break;

	'''
	look for a second Humbert surface containing the moduli point corresponding to our variety
	'''	
	for j in range(F+1,MaxDiscriminant):
		if(HumbertTest[j] == 1):
			S=j;
			break;

	if(verbose):
		print("The surface lies on the intersection of the Humbert surfaces of discriminants", F, "and", S);

	'''
	We now know that the matrix corresponding to the quaternionic ring in question
	has the form [[F n], [n S]]. Compute an upper bound for n.
	'''

	upperBound=floor((F*S)^0.5);
	Possibilities=[1 for j in range(upperBound+1)];

	for j in range(upperBound+1):
		if(j%2 == 1):
			Possibilities[j]=0;
		else:
			if(HumbertTest[F+S-2*j]==0):
				Possibilities[j]=0;
			else:
						if(4*F+S-4*j<=MaxDiscriminant-1):
							if(HumbertTest[4*F+S-4*j]==0 and (S%4==0 or 4*F+S-4*j<=24) ):
								Possibilities[j]=0;
							else:
								Possibilities[j]=1;


	if(sum(Possibilities)==1):
		for j in range(upperBound+1):
			if(Possibilities[j]==1):
				OffDiagonalEntry=j;
		poly=ZZ['x']([a0,a1,a2,a3,a4,a5,a6])
		RepresentingMatrix=Matrix(Integers(),2,2,[F,OffDiagonalEntry,OffDiagonalEntry,S]);
		if(verbose):
			print("The Jacobian of the curve with equation", poly, "has QM by an order with associated matrix\n",RepresentingMatrix);
			print("The discriminant of the quaternionic ring is", RepresentingMatrix.det()/4);
		return RepresentingMatrix;

