attach("level1upto13.sage");
attach("Level2HumbertSurfaces.m");
attach("SatakeInvariants.sage");

HSurfaces=[symm1,0,0,symm4,symm5,0,0,symm8,symm9,0,0,symm12,symm13,0,0,symm16,symm17,0,0,symm20,symm21];

def HTest(d,a0,a1,a2,a3,a4,a5=1,a6=0,verbose=false):
	if d % 4 == 2 :
		return false;
	if d % 4 == 3 :
		return false;
	if(verbose):
		print("Testing if curve belongs to the Humbert surface of discriminant", d);
	t2,t3,t5,t6=SatakeInvariants(a0,a1,a2,a3,a4,a5,a6,verbose);
	if(d<22) :
		return HSurfaces[d-1](t6,t5,t3,t2)==0;

	t1=0;
	t4=t2^2/4;

	if (d >= 24 and d<=40) :
		return magma.testHumbertSurface(d,t1,t2,t3,t4,t5,t6);
	if (d > 40 and d%8==4) :
		return magma.testHumbertSurface(d,t1,t2,t3,t4,t5,t6);

	return false;
 
  
def CertifyRM(a0,a1,a2,a3,a4,a5=1,a6=0,verbose=false) :
	for d in range(5,41):
		if HTest(d,a0,a1,a2,a3,a4,a5,a6,verbose) :
			return d;
	return -1;
